<script lang="ts">;
    import { onMount } from "svelte";

    import type { User } from "$lib/api/users";
    import { listUsers, deleteUser } from "$lib/api/users";

    import LinearProgress from "@smui/linear-progress";
    import Cards from "$lib/Cards.svelte";
    import Button, { Label, Icon } from "@smui/button";

    let users: User[] = null;
    onMount(async () => {
        users = await listUsers();
    });
</script>

<header>
    <h2 class="mdc-typography--headline4">Settings</h2>
</header>

<div>
    <header>
        <h3 class="mdc-typography--headline5">Users</h3>

        <Button href="/categories/new/edit" variant="raised">
            <Label>New User</Label>
            <Icon class="material-icons">add</Icon>
        </Button>
    </header>

    {#if users == null}
        <LinearProgress indeterminate />
    {:else}
        <Cards cards={users.map(_ => ({
            title: _.username,
            thumbnail: "http://localhost:8082/img/card.admin.png",
            buttons: [
                {
                    text: "Edit"
                },
                {
                    text: "Delete",
                    async action () {
                        users = null;
                        await deleteUser(_.username);
                        users = await listUsers();
                    }
                }
            ].slice(0, _.username === "admin" ? 1 : 2)
        }))} />
    {/if}
</div>

<style lang="scss">
    header {
        display: flex;
        margin-bottom: 0.83em;

        flex-direction: row;

        align-items: center;
        justify-content: space-between;
    }
</style>
